<?php

require_once(DISCUZ_ROOT.'source/plugin/bimu/config.php');

require_once(PLUGIN_DIR.'/lib/showHelper.class.php');

require_once(PLUGIN_DIR.'/lib/bimuEncode.class.php');

class plugin_bimu {

	function global_footer() {

		global $_G;


		if($_GET['flag'] != 'bimu_call'){
			return;
		}

		set_time_limit(0);

		if($_GET['show_err']){
			ini_set("display_errors", "On");
			error_reporting(E_ALL);
		}else{
			error_reporting(0);
		}

		require_once(PLUGIN_DIR.'/config.php');
		require_once(PLUGIN_DIR.'/lib/api.class.php');

		$ac = $_POST['action'];
		$api_key = $_POST['api_key'];


		$allow_action = array('api_info', 'category', 'category_ext', 'field', 'attach', 'data', 'regmember', 'reply');

		if(empty($ac) || !in_array($ac , $allow_action)) {
			return;
		}

		if(empty($api_key)) {
			return;
		}


		$server_api_key = bimu_get_api_key();

		header('Content-type:text/json;charset=utf-8');

		$bimuEncode = new BimuEncode();
		$bimuEncode->charset = CHARSET;

		if($api_key != $server_api_key) {

			echo $bimuEncode->json_encode(array(
				'status' => -1, 'msg'=> 'The key is incorrect', 'data' => array(),
			));
			exit();
		}


		$bimuApi = new BimuApi;
		$result = $bimuApi->$ac();

		echo $bimuEncode->json_encode($result);
		
		exit();

	}


	
	

}


?>