<?php

require_once(PLUGIN_DIR.'/lib/common.class.php');
require_once(PLUGIN_DIR.'/lib/common.func.php');
require_once(PLUGIN_DIR.'/lib/function.member.php');
require_once(PLUGIN_DIR.'/lib/article.class.php');



class BimuApi{
	
    function init(){

    }

    public function api_info(){

        $result_data = array('status' => 0, 'msg'=> 'ok', 'data' => array());

        $res = BimuCommon::dmkdir(PLUGIN_ATTACH_CACHE_DIR);



        $system['cms_type'] = 'discuz';
        $system['cms_vertion'] = DISCUZ_VERSION;
        $system['api_version'] = PLUGIN_VERSION;
        $system['charset'] = CHARSET;
        $result_data['data'] = $system;

        return $result_data;

    }


    public function category(){

        global $_G;

    
        $result_data = array('status' => 0, 'msg'=> 'ok', 'data' => array());
    
    
        //门户
        loadcache('portalcategory');
        $category = $_G['cache']['portalcategory'];
        $category_data['portal'] = array('name' => stlang('portal'), 'id' => 'portal');
        foreach ($category as $key => $value) {

            $name = $value['catname'];

            $category_data['portal']['data'][] = array('id' => $value['catid'], 'name' => $name, 'parent_id' => $value['upid'], 'disabled' => 0);
        }


        //帖子

        $is_open_group = helper_access::check_module('group');

        $where_sql = $is_open_group == 1 ? '' :  'where status=1';

        $category_data['thread'] = array('name' => stlang('thread'), 'id' => 'thread');
		$query = DB::query('SELECT * FROM '.DB::table('forum_forum')." ".$where_sql." order by fid desc");
		while($value = DB::fetch($query)) {

            $name = $value['name'];

            $category_data['thread']['data'][] = array('id' => $value['fid'], 'name' => $name, 'parent_id' => $value['fup'], 'disabled' => $value['type'] == 'group' ? 1 : 0);
        }


        $result_data['data']['level'] = 2;//层级
        $result_data['data']['multiselect'] = 0;//是否多选
        $result_data['data']['api_callback'] = 'category.ext';//选择分类是否需要回调请求
        $result_data['data']['category_data'] = $category_data;


        return $result_data;
    
    }

    public function category_ext(){

        global $_G;

        $result_data = array('status' => 0, 'msg'=> 'ok', 'data' => array());

        $public_type = $_POST['topid'];
        $fid = $_POST['cid'];



        if($public_type == 'portal'){
            return $result_data;
        }


        $field_data = array();

        //主题分类字段
        $query = DB::query("SELECT typeid,name,displayorder FROM ".DB::table('forum_threadclass')." WHERE  fid='$fid' ORDER BY displayorder");
        $data = array();
        while($rs = DB::fetch($query)) {
            $data[] = array('id' => $rs['typeid'], 'name' => $rs['name'], 'disabled' => 0);
        }

        $field_data['typeid'] = array('id' => 'typeid', 'name' => stlang('thread_type_name'), 'type' => 'select', 'data' => $data);

        //分类信息字段
        $forum_forumfield_info = DB::fetch_first("SELECT threadsorts,moderators FROM ".DB::table('forum_forumfield')." WHERE fid='$fid'");
        $threadsorts_data = dunserialize($forum_forumfield_info['threadsorts']);
        $types = $threadsorts_data['types'];
        $data = array();
        foreach($types as $typeid => $name){
            $data[] = array('id' => $typeid, 'name' => $name, 'disabled' => 0);
        }

        $field_data['sortid'] = array('id' => 'sortid', 'name' => stlang('sort_name'), 'type' => 'select', 'data' => $data);


        $result_data['data'] = $field_data;

        return $result_data;

    }


    public function field(){

        global $_G;
    
        $result_data = array('status' => 0, 'msg'=> 'ok', 'data' => array());
    
        $field_tpl_forum = array(
    
            'title' => array(
                'key' => 'title',
                'name' => stlang('title'),
            ),
            'content' => array(
                'key' => 'content',
                'name' => stlang('content'),
            ),
    
            'thumb' => array(
                'key' => 'thumb',
                'name' => stlang('thumb'),
            ),
    
            'public_username' => array(
                'key' => 'public_username',
                'name' => stlang('public_username'),
            ),
            'public_avatar' => array(
                'key' => 'public_avatar',
                'name' => stlang('public_avatar'),
            ),
            'public_dateline' => array(
                'key' => 'public_dateline',
                'name' => stlang('public_dateline'),
            ),
            'reply' => array(
                'key' => 'reply',
                'name' => stlang('reply'),
            ),
            'reply_username' => array(
                'key' => 'reply_username',
                'name' => stlang('reply_username'),
            ),
            'reply_avatar' => array(
                'key' => 'reply_avatar',
                'name' => stlang('reply_avatar'),
            ),
            'reply_dateline' => array(
                'key' => 'reply_dateline',
                'name' => stlang('reply_dateline_field'),
            ),
    
    
        );
    
    
    
        $field_tpl_portal = array(
    
            'title' => array(
                'key' => 'title',
                'name' => stlang('title'),
            ),
            'content' => array(
                'key' => 'content',
                'name' => stlang('content'),
            ),
    
            'thumb' => array(
                'key' => 'thumb',
                'name' => stlang('thumb'),
            ),
    
            'public_dateline' => array(
                'key' => 'public_dateline',
                'name' => stlang('public_dateline'),
            ),
    
            'from' => array(
                'key' => 'from',
                'name' => stlang('article_from'),
            ),
    
            'fromurl' => array(
                'key' => 'fromurl',
                'name' => stlang('fromurl'),
            ),
    
    
    
            'author' => array(
                'key' => 'author',
                'name' => stlang('ori_author'),
            ),
    
            'thumb' => array(
                'key' => 'thumb',
                'name' => stlang('thumb'),
            ),
    
        );
    
    
    
        $catid = $_GET['cid'];
        $public_type = $_GET['topid'];
        $sortid = $_GET['sortid'];
        $typeid = $_GET['typeid'];
    
    
    
        $field_data = $public_type == 'thread' ? $field_tpl_forum : $field_tpl_portal;
    
    
        if($public_type == 'thread'){
            $fid = $catid;
            $threadsortid = $sortid;
            $ext_field_data = $this->get_threadtypes_field_data($fid, $threadsortid);
            $field_data = array_merge($field_data, $ext_field_data);
        }else {
            $field_data = $field_tpl_portal;
        }
    
    
        $result_data['data']['bind'] = $field_data;
    
        $result_data['data']['ext'] = array(
    
            'is_htmlon' => array(
                'type' => 'radio',
                'name' => stlang('is_htmlon'),
                'desc' => '',
                'default_val' => 0,
                'data' => array(
    
                    0 => array(
                        'name' => stlang('yes'),
                        'val' => 1,
                    ),
    
                    1 => array(
                        'name' => stlang('no'),
                        'val' => 0,
                    )
    
                ),
    
            ),
    
        );
    
    
        return $result_data;
    
    
    }

    

    public function attach(){

        global $_G;
    
    
        $result_data = array('status' => 0, 'msg'=> '', 'data' => array());
    
        $post_data = BimuCommon::get_post_data();

        $content = BimuCommon::base64_decode($_POST['content']);
    
        $fpath = bimu_get_attach_save_path($post_data['data_id'], $post_data['_id']);
    
    
        $fp = fopen($fpath, "w");
        fwrite($fp, $content);
    
    
        return $result_data;
    
    
    }

    public function regmember(){

        global $_G;
    
        $result_data = array('status' => 0, 'msg'=> '', 'data' => array());
        $post_data = BimuCommon::get_post_data();

        $reg_data = $post_data['reg_data'];
        $data_id = $post_data['data_id'];
        $avatar = $reg_data['avatar'];
        $attach_id = $avatar['_id'];
    
        $fpath = bimu_get_attach_save_path($data_id, $attach_id);
    
        $info = array();
        $info['username'] = $reg_data['username'];
		$info['password'] = $reg_data['reg_member_pwd'];

		$reg_info = DB::fetch_first("SELECT uid,username FROM ".DB::table('common_member')." WHERE username ='".$info['username']."'");

       
		if($reg_info['uid']) {
			return $result_data;
		}


		$info = get_member_setarr($info);

		$reg_info = dxc_member_reg($info);

		if($reg_info['errno'] == -3){//已经被注册了
			return $result_data;
		}

		if($reg_info['errno']) {
            $result_data['status'] = -1;
            $result_data['msg'] = $reg_info['errmsg'];
			return $result_data;
		}

        //设置头像

        $res = member_set_avatar($reg_info['uid'], $fpath, $avatar['ext']);


        return $result_data;


    }


    public function data(){

        global $_G;

    
        $result_data = array('status' => 0, 'msg'=> '', 'data' => array());

        $post_data = BimuCommon::get_post_data();
        
        $aimuArticle = new BimuArticle($post_data);

        return $aimuArticle->start();
    
    
    }


    public function reply(){

        global $_G;

      
    
        $result_data = array('status' => 0, 'msg'=> '', 'data' => array());

        $post_data = BimuCommon::get_post_data();


        
        $aimuArticle = new BimuArticle($post_data);

        return $aimuArticle->start();
    
    
    }



    private function get_threadtypes_field_data($fid, $sortid){

        global $_G;
    
        loadcache(array('threadsort_option_'.$sortid));
    
        $sortoptionarray = $_G['cache']['threadsort_option_'.$sortid];
    
    
        $field_data = array();
    
        foreach($sortoptionarray as $k => $v){
            $identifier = $v['identifier'];
            $field_data[$identifier] = array('key' => $identifier, 'name' => $v['title']);
        }
    
        return $field_data;
    
    }


    

}
?>