<?php


class BimuEncode{

	var $charset = 'utf-8';

	function json_encode($data){
		$data = $this->iconv_data($data);
		return json_encode($data);
	}

	function iconv_data($data){

		if(is_array($data)){
			foreach($data as $k => $v){
				$data[$k] = $this->iconv_data($v);
			}
		}else{
			$data = $this->str_iconv_to_utf8($data);
		}

	    return $data;
	}

	function str_iconv_to_utf8($str){
		if($this->charset == 'gbk' || $this->charset == 'gb2312'){
			$str = $this->piconv($str, 'GBK', 'UTF-8');
		}else{
			if($this->charset == 'big5') {
				$str = $this->piconv($str, 'BIG5', 'UTF-8');
			}else{
			}
	  	}

		return $str;
	}

	function piconv($str, $in, $out){
		if(function_exists('mb_convert_encoding')) {
			$str = $in == 'UTF-8' ? str_replace("\xC2\xA0", ' ', $str) : $str;
			$str = mb_convert_encoding($str, $out, $in);
		}else{
			$str = iconv($in, "".$out."//IGNORE", $str);
		}
		return $str;
	}


}

?>
