<?php

    if(!defined('IN_DISCUZ')) {
        exit('Access Denied');
    }


    class BimuArticle{

        var $post_data;
        var $api_info;
        var $public_type;
        var $cache;
        var $errno;
        var $errmsg;
        var $is_bbs;

        function BimuArticle($post_data){

            global $_G;


            $_G['uid'] = !empty($_G['uid']) ? $_G['uid'] : 1;

            $this->cache = array(
                'common' => array(

                ),
                'error' => array(
                    'status' => 0,
                    'msg' => '',
                ),
            );

            $this->post_data = $post_data;
            

        }


        private function format_attach_data(){

            foreach($this->post_data['attach_data'] as $key1 => $value1){


                foreach($value1 as $key2 => $value2){
        
                    $fpath = $this->_get_attach_save_path($this->post_data['_id'], $value2['_id']);
        
                    $this->post_data['attach_data'][$key1][$key2]['fpath'] = $fpath;
                }
        
            }
        }
      


        function check_evn(){

            $public_type = $this->post_data['cat_data']['topid'];


            return array('status' => 0, 'msg'=> '', 'data' => array());


        }


        public function start(){

            $result_data = array('status' => 0, 'msg'=> '', 'data' => array());

            $check_res = $this->check_evn();


            if($check_res.status != 0) {
                return $check_res;
            }

            $public_type = $this->post_data['cat_data']['topid'];

            $this->format_attach_data();

            
            //发布到论坛
            if($public_type == 'thread'){
                sload('F:member');
                $this->move_forums();
            }else if($public_type == 'portal'){//门户
                $this->move_portal();
            }else if($public_type == 'reply'){//评论
                sload('F:member');
                $this->reply_public();
            }else if($public_type == 'group'){//群组
                $this->move_portal();
            }

            if($this->cache['error']['status'] < 0){
                return $this->cache['error'];
            }


            $result_data['data'] = $this->cache['finish'];

            return $result_data;

        }


        function _get_attach_save_path($data_id, $attach_id){

            return bimu_get_attach_save_path($data_id, $attach_id);


        }



        function move_portal(){

            global $_G;

            require_once libfile('function/home');
            require_once libfile('function/portalcp');


            $subject = getstr($this->post_data['field_data']['title'], 80, 0, 0);

            $content = $this->post_data['field_data']['content'];

            $view_num = $this->post_data['file_ext']['view_num'];

            $catid = $this->post_data['cat_data']['cid'];

            loadcache('portalcategory');
            $cat_arr = $_G['cache']['portalcategory'];
            $cat_info = $cat_arr[$catid];
            $contents = 0;

            if(empty($summary)) $summary = portalcp_get_summary(stripslashes($content));

            $dateline = $this->get_article_dateline();


            $public_username = $this->post_data['field_data']['public_username'];
            $public_uid = $this->post_data['field_ext']['public_uid'];

            $member_info = $this->get_public_member_info($public_username, $public_uid);

            $uid = $member_info['uid'];
            $username = $member_info['username'];

            $pic = $arr['pic'] ? $_thumb.addslashes($arr['pic']) : '';
            $thumb = 0;
            $remote = 0;
            $setarr = array(
                            'title' => $subject,
                            'author' => $this->field_data['author'],
                            'from' => $this->field_data['from'],
                            'catid' => $catid,
                            'pic' => $pic,
                            'thumb' => $thumb,
                            'remote' => $remote,
                            'fromurl' => $this->field_data['fromurl'],
                            'dateline' => $dateline,
                            'url' => '',
                            'allowcomment' => $cat_info['allowcomment'],
                            'summary' => $summary,
                            'tag' => '',
                            'status' => 0,
                            'highlight' => $style,
                            'showinnernav' => empty($arr['showinnernav']) ? '0' : '1',
                            'uid' => $uid,
                            'username' => $username,
                            'contents' => $contents
                            );
            if($this->post_data['data_id']){
                $info = DB::fetch_first("SELECT catid,aid FROM ".DB::table('portal_article_title')." WHERE aid='".$this->post_data['data_id']."'");
                pic_delete($info['pic'], 'portal', $info['thumb'], $info['remote']);

                $query = DB::query("SELECT * FROM ".DB::table('portal_attachment')." WHERE aid='".$this->post_data['data_id']."' ORDER BY attachid DESC");
                while ($value = DB::fetch($query)) {
                    pic_delete($value['attachment'], 'portal', $value['thumb'], $value['remote']);
                }
                DB::query('DELETE FROM '.DB::table('portal_attachment')." WHERE aid='".$this->post_data['data_id']."'");//…æ≥˝ƒø«∞µƒ ˝æ›‘Ÿ∏¸–¬

            }
            if(!$info['aid']){
                $aid = DB::insert('portal_article_title', st_addslashes($setarr), 1);
                DB::update('common_member_status', array('lastpost' => $dateline), array('uid' => $uid));
            }else{
                DB::update('portal_article_title', st_addslashes($setarr), array('aid' => $this->post_data['data_id']));
                DB::query('UPDATE '.DB::table('portal_category')." SET articles=articles-1 WHERE catid='".$catid."'");
                $aid = $this->post_data['data_id'];
            }

            $count_setarr = array(
                                'viewnum' => $view_num,
                                'dateline' => $dateline,
                                );
            if(DISCUZ_VERSION != 'X2'){
                unset($count_setarr['dateline']);

            }
            $view_check = DB::fetch_first("SELECT aid FROM ".DB::table('portal_article_count')." WHERE aid='".$aid."'");
            if($view_check){
                DB::update('portal_article_count', $count_setarr, array('aid' => $aid));
            }else{
                $count_setarr['aid'] = $aid;
                DB::insert('portal_article_count', $count_setarr);
            }

            $relatedarr = dunserialize($this->cache['article_info']['raids']);
            DB::query('DELETE FROM '.DB::table('portal_article_related')." WHERE aid='$aid'");
            DB::query('DELETE FROM '.DB::table('portal_article_related')." WHERE raid='$aid'");

            if($relatedarr) {
                $query = DB::query("SELECT * FROM ".DB::table('portal_article_title')." WHERE aid IN (".dimplode($relatedarr).")");
                $list = array();
                while(($value=DB::fetch($query))) {
                    $list[$value['aid']] = $value;
                }
                $replaces = array();
                $displayorder = 0;
                foreach($relatedarr as $relate) {
                    if(($value = $list[$relate])) {
                        if($value['aid'] != $aid) {
                            $replaces[] = "('$aid', '$value[aid]', '$displayorder')";
                            $replaces[] = "('$value[aid]', '$aid', '0')";
                            $displayorder++;
                        }
                    }
                }
                if($replaces) {
                    DB::query("REPLACE INTO ".DB::table('portal_article_related')." (aid,raid,displayorder) VALUES ".implode(',', $replaces));
                }
            }

            if(DISCUZ_VERSION != 'X2' && DISCUZ_VERSION != 'X2.5'){
                $pre_next_arr = portalcp_article_pre_next($catid, $aid);
                DB::update('portal_article_title', $pre_next_arr, array('aid' => $aid));
            }

            DB::query('UPDATE '.DB::table('portal_category')." SET articles=articles+1 WHERE catid='".$catid."'");

            $this->cache['common']['public_uid'] = $uid;
            $this->cache['common']['public_username'] = $username;
            $this->cache['common']['public_time'] = $dateline;
            $this->cache['common']['catid'] = $catid;
            $this->cache['common']['aid'] = $aid;

            $this->cache['finish']['data_id'] = $aid;
            $this->cache['finish']['data_url']  = $_G['siteurl'].'portal.php?mod=view&aid='.$aid;



            $this->portal_attach_content($content);


        }


        function portal_attach_ftp_upload($attach){
            global $_G;
            $dir_name = 'portal';
            $ftpresult_thumb = 0;
            $ftpresult = ftpcmd('upload', $dir_name.'/'.$attach['attachment']);
            if($ftpresult) {
                @unlink($_G['setting']['attachdir'].$dir_name.'/'.$attach['attachment']);
                $thumbpath = getimgthumbname($attach['attachment']);
                ftpcmd('upload', $dir_name.'/'.$thumbpath);
                @unlink($_G['setting']['attachdir'].$dir_name.'/'.$thumbpath);
            }
        }



        //门户
        function portal_attach_content($content){



            global $_G;

            require_once libfile('class/image');

            $attach_arr = $this->post_data['attach_data']['content'];


            $public_time = $this->cache['common']['public_time'] ? $this->cache['common']['public_time'] : $_G['timestamp'];


            bimu_upload_class();

            $upload = new discuz_upload();
            $content_md5_arr = array();
            $imagereplace = $aids = array();
            $attach_dir_name = 'portal';



            //处理a标签
            foreach($attach_arr as $key => $value){

                if($value['isimage'] == 'true'){
                    continue;
                }


                $tempvalue = $value;
                $imageurl =  $tempvalue['src'];

                if($tempvalue['user_oss_url']){
                    $imageurl = $tempvalue['user_oss_url'];
                }

                $attach = array();
                $attach['ext'] = $value['ext'];
                $imagereplace['img_search'][$key] = $value['ref'];

                $isimage = $value['isimage'];

                $style_str = $value['style'] ? 'style="'.$value['style'].'"' : '';

                $imagereplace['img_replace'][$key] = '<p style="text-align: center;"><a '.$style_str.' href="'.$imageurl.'" target="_blank" >'.$imageurl.'</a></p>';

                $img_content = $value['download_status'] == 1 && !empty($value['fpath']) ? file_get_contents($value['fpath']) : null;

                if(empty($img_content) || empty($attach['ext'])) {
                    continue;
                }


                $attach['name'] = $value['realName'] ? $value['realName'] : $value['_id'].'.'.$value['ext'];
                $attach['thumb'] = '';
                $attach['isimage'] = $isimage;
                $attach['attachment'] = $upload -> get_target_dir($attach_dir_name) . $upload->get_target_filename($attach_dir_name).'.'.$attach['ext'];
                $attach['extension'] = $upload -> get_target_extension($attach['ext']);
                $attach['attachdir'] = $upload -> get_target_dir($attach_dir_name);
                $attach['target'] = getglobal('setting/attachdir').'./'.$attach_dir_name.'/'.$attach['attachment'];


                if(!@$fp = fopen($attach['target'], 'wb')) {
                    continue;
                } else {
                    flock($fp, 2);
                    fwrite($fp, $img_content);
                    fclose($fp);
                }

                $attach['size'] = strlen($value['content']);
                $attach = daddslashes($attach);


                $remote = 0;
                if($_G['setting']['ftp']['on'] && $this->ftp_check_attach($attach['ext'], $attach['size'])){
                    $remote = 1;
                    $this->portal_attach_ftp_upload($attach);
                }

                $attach['remote'] = $remote;


                $setarr = array(
                    'uid' => $this->cache['common']['public_uid'],
                    'filename' => $attach['name'],
                    'attachment' => $attach['attachment'],
                    'filesize' => $attach['size'],
                    'isimage' => $attach['isimage'],
                    'thumb' => $attach['thumb'],
                    'remote' => $attach['remote'],
                    'filetype' => $attach['extension'],
                    'dateline' => $this->cache['common']['public_time'],
                    'aid' => $this->cache['common']['aid']
                );



                $setarr['attachid'] = DB::insert("portal_attachment", paddslashes($setarr), true);
                if($remote == 1){
                    $aids[$setarr['attachid']] = $setarr['attachid'];
                    $this->cache['upload']['attach_arr'][$setarr['attachid']] = $setarr;
                }

                $attach['url'] = ($attach['remote'] ? $_G['setting']['ftp']['attachurl'] : $_G['setting']['attachurl']).''.$attach_dir_name.'/';

                $attach_url = 'portal.php?mod=attachment&amp;id='.$setarr['attachid'];
                $imagereplace['img_replace'][$key] = '<p style="text-align: center;"><a '.$style_str.' href="'.$attach_url.'" target="_blank" class="attach">'.($value['text'] ? $value['text'] : $attach['name']).'</a></p>';


            }



            $content = str_replace($imagereplace['img_search'], $imagereplace['img_replace'], $content);


            $imagereplace = array();

            $cover_pic_attachment = array();//封面


            //处理img标签
            foreach($attach_arr as $key => $value){

                if($value['isimage'] !== 'true'){
                    continue;
                }


                $tempvalue = $value;
                $imageurl =  $tempvalue['src'];

                if($value['user_oss_url']){
                    $imageurl = $value['user_oss_url'];
                }

                $attach = array();
                $attach['ext'] = $value['ext'];
                $imagereplace['img_search'][$key] = $value['ref'];


                $isimage = $value['isimage'];
                $imagereplace['img_replace'][$key] = '<p style="text-align: center;"><a href="'.$imageurl.'" target="_blank"><img src="'.$imageurl.'"></a></p>';

                $img_content = $value['download_status'] == 1 && !empty($value['fpath']) ? file_get_contents($value['fpath']) : null;


                $attach['name'] = $value['realName'] ? $value['realName'] : $value['_id'].'.'.$value['ext'] ;


                if(empty($img_content) || empty($attach['ext'])) {
                    continue;
                }



                $attach['thumb'] = '';
                $attach['isimage'] = $isimage == 'true' ? 1 : 0;
                $attach['attachment'] = $upload -> get_target_dir($attach_dir_name) . $upload->get_target_filename($attach_dir_name).'.'.$attach['ext'];
                $attach['extension'] = $upload -> get_target_extension($attach['ext']);
                $attach['attachdir'] = $upload -> get_target_dir($attach_dir_name);
                $attach['target'] = getglobal('setting/attachdir').'./'.$attach_dir_name.'/'.$attach['attachment'];


                if(!@$fp = fopen($attach['target'], 'wb')) {
                    continue;
                } else {
                    flock($fp, 2);
                    fwrite($fp, $img_content);
                    fclose($fp);
                }
                if(!$upload->get_image_info($attach['target']) && $attach['isimage'] == 1) {
                    @unlink($attach['target']);
                    continue;
                }

                if(empty($cover_pic_attachment)){
                    $cover_pic_attachment = $attach['attachment'];
                }

                $attach['size'] = strlen($value['content']);
                $attach = daddslashes($attach);

                if($attach['isimage'] && empty($_G['setting']['portalarticleimgthumbclosed'])) {
                    $image = new image();
                    $thumbimgwidth = $_G['setting']['portalarticleimgthumbwidth'] ? $_G['setting']['portalarticleimgthumbwidth'] : 300;
                    $thumbimgheight = $_G['setting']['portalarticleimgthumbheight'] ? $_G['setting']['portalarticleimgthumbheight'] : 300;
                    $result = $image->Thumb($attach['target'], '', $thumbimgwidth, $thumbimgheight, 2);
                    $attach['thumb'] = empty($result)?0:1;
                    $image->Watermark($attach['target'], '', $attach_dir_name);
                }

                $remote = 0;
                if($_G['setting']['ftp']['on'] && $this->ftp_check_attach($attach['ext'], $attach['size'])){
                    $remote = 1;
                    $this->portal_attach_ftp_upload($attach);
                }

                $attach['remote'] = $remote;


                $setarr = array(
                    'uid' => $this->cache['common']['public_uid'],
                    'filename' => $attach['name'],
                    'attachment' => $attach['attachment'],
                    'filesize' => $attach['size'],
                    'isimage' => $attach['isimage'],
                    'thumb' => $attach['thumb'],
                    'remote' => $attach['remote'],
                    'filetype' => $attach['extension'],
                    'dateline' => $this->cache['common']['public_time'],
                    'aid' => $this->cache['common']['aid']
                );
                $setarr['attachid'] = DB::insert("portal_attachment", paddslashes($setarr), true);
                if($remote == 1){
                    $aids[$setarr['attachid']] = $setarr['attachid'];
                    $this->cache['upload']['attach_arr'][$setarr['attachid']] = $setarr;
                }

                $attach['url'] = ($attach['remote'] ? $_G['setting']['ftp']['attachurl'] : $_G['setting']['attachurl']).''.$attach_dir_name.'/';


                $attach_url = $attach['url'].$attach['attachment'];
                $imagereplace['img_replace'][$key] = '<img src="'.$attach_url.'">·';


            }


            $content = str_replace($imagereplace['img_search'], $imagereplace['img_replace'], $content);


            $this->cache['upload']['newaids'] = $aids;


            $aid = $this->cache['common']['aid'];


            $content = getstr($content, 0, 0, 1, 0, 1);
            $article_status = 0;
            $regexp = '/(###NextPage(\[title=(.*?)\])?###)+/';
            preg_match_all($regexp, $content ,$arr);
            $pagetitle = $arr[3];
            $pagetitle = array_map('trim', $pagetitle);
            $content_arr = preg_split($regexp, $content);
            $content_count = count($contents);
            $pageorder = intval($arr['pageorder']);
            $id = 0;

            $old_portal_id = $this->post_data['data_id'];//旧的发布id

            if($old_portal_id){
                DB::query('DELETE FROM '.DB::table('portal_article_content')." WHERE aid ='".$old_portal_id."'");
            }

            DB::query('DELETE FROM '.DB::table('portal_article_content')." WHERE aid ='$aid'");
            $idtype = '';
            $thumb = $cover_pic ? 1 : 0;
            $remote = 0;


            //设置封面
            if($content_arr) {

                $attach_img_info = $this->post_data['attach_data']['thumb'][0];

                if($attach_img_info){

                    $save_name = $attach_img_info['save_name'];
                    $attachdir = $upload -> get_target_dir('portal');
                    $attachment = $attachdir . $upload->get_target_filename('portal').'.'.$attach_img_info['ext'];
                    $this->cache['upload']['cover']['attachment'] = $attachment;

                    $remote = $_G['setting']['ftp']['on'] == 1 ? 1 : 0;

                    $setarr = array(
                        'uid' => $this->cache['common']['public_uid'],
                        'filename' => $attach_img_info['realName'] ? $attach_img_info['realName'] : $attach_img_info['_id'].'.'.$attach_img_info['ext'] ,
                        'attachment' => $attachment,
                        'filesize' => $attach_img_info['size'],
                        'isimage' => 1,
                        'thumb' => 1,
                        'remote' => $remote,
                        'filetype' => $attach_img_info['ext'],
                        'dateline' => $this->cache['common']['public_time'],
                        'aid' => $this->cache['common']['aid']
                    );


                    $setarr['attachid'] = DB::insert("portal_attachment", paddslashes($setarr), true);
                    $root_url = ($remote ? $_G['setting']['ftp']['attachurl'] : $_G['setting']['attachurl']).''.$attach_dir_name.'/';

                    $img_content = $attach_img_info['download_status'] == 1 && !empty($attach_img_info['fpath']) ? file_get_contents($attach_img_info['fpath']) : $attach_img_info['src'];

                    $attach_img_info['content'] = $img_content;

                    $cover_pic = $this->setcover_article($attach_img_info['content'], $attachment);


                    if($_G['setting']['ftp']['on']){
                        $remote = 1;
                        $this->portal_attach_ftp_upload($setarr);
                    }


                }else{

                    if($_G['setting']['ftp']['on'] == 1){
                        @unlink(getglobal('setting/attachdir').'./'.$cover_pic);
                        $remote = 1;
                    }

                    if($cover_pic_attachment){
                        $cover_pic = 'portal/'.$cover_pic_attachment;
                    }

                }


                $thumb = $cover_pic ? 1 : 0;

                $inserts = array();
                foreach ($content_arr as $key => $value) {
                    $value = trim($value);
                    $inserts[] = "('$aid', '".(empty($pagetitle[$key-1]) && $content_count > 1 ? $this->cache['article_info']['title'] : $pagetitle[$key-1])."', '$value', '".($pageorder+$key)."', '".$this->cache['common']['public_time']."', '$id', '$idtype')";
                }
                DB::query("INSERT INTO ".DB::table('portal_article_content')."
                    (aid, title, content, pageorder, dateline, id, idtype)
                    VALUES ".implode(',', $inserts));

                DB::query('UPDATE '.DB::table('portal_article_title')." SET status = '$article_status',pic = '".$cover_pic."', thumb='$thumb', remote='$remote', contents = ".count($inserts)." WHERE aid='$aid'");
            }



        }


        function setcover_article($cover_pic_content, $attachment, $type_dir = 'portal'){
            
            global $_G;
            $image = new image();
            $thumbimgwidth = $_G['setting']['portalarticleimgthumbwidth'] ? $_G['setting']['portalarticleimgthumbwidth'] : 300;
            $thumbimgheight = $_G['setting']['portalarticleimgthumbheight'] ? $_G['setting']['portalarticleimgthumbheight'] : 300;
            if(empty($cover_pic_content)) return;
            $target = getglobal('setting/attachdir').'./'.$type_dir.'/'.$attachment;
            file_put_contents($target, $cover_pic_content);
            $thumb = $image->Thumb($target, '', $thumbimgwidth, $thumbimgheight, 2);
            if($thumb){
                $cover_pic = $type_dir == 'portal' ? $type_dir.'/'.$attachment : $attachment;
                return $cover_pic;
            }
            return FALSE;

        }


        function forum_set_cover($tid, $picsource){
            global $_G;
            $basedir = !$_G['setting']['attachdir'] ? (DISCUZ_ROOT.'./data/attachment/') : $_G['setting']['attachdir'];
            $coverdir = 'threadcover/'.substr(md5($tid), 0, 2).'/'.substr(md5($tid), 2, 2).'/';
            dmkdir($basedir.'./forum/'.$coverdir);
            $image = new image();
            if($_G['setting']['forumpicstyle'] && !is_array($_G['setting']['forumpicstyle'])){
                $_G['setting']['forumpicstyle'] = dunserialize($_G['setting']['forumpicstyle']);
            }
            if(!$_G['setting']['forumpicstyle']) $_G['setting']['forumpicstyle'] = $this->load_forumpicstyle();
            empty($_G['setting']['forumpicstyle']['thumbwidth']) && $_G['setting']['forumpicstyle']['thumbwidth'] = 203;
            empty($_G['setting']['forumpicstyle']['thumbheight']) && $_G['setting']['forumpicstyle']['thumbheight'] = 999;


            if($image->Thumb($picsource, 'forum/'.$coverdir.$tid.'.jpg', $_G['setting']['forumpicstyle']['thumbwidth'], $_G['setting']['forumpicstyle']['thumbheight'], 2)) {
                DB::update('forum_thread', array('cover' => 1), array('tid'=>$tid));
            }else{
            }

        }


        function ftp_check_attach($ext, $filesize){
            global $_G;
            if(!$_G['setting']['ftp']['on']) return TRUE;
            if(((!$_G['setting']['ftp']['allowedexts'] && !$_G['setting']['ftp']['disallowedexts']) || ($_G['setting']['ftp']['allowedexts'] && in_array($ext, $_G['setting']['ftp']['allowedexts'])) || ($_G['setting']['ftp']['disallowedexts'] && !in_array($ext, $_G['setting']['ftp']['disallowedexts']) && (!$_G['setting']['ftp']['allowedexts'] || $_G['setting']['ftp']['allowedexts'] && in_array($ext, $_G['setting']['ftp']['allowedexts'])))) && (!$_G['setting']['ftp']['minsize'] || $filesize >= $_G['setting']['ftp']['minsize'] * 1024)) {
                return TRUE;
            }else{
                return FALSE;
            }
        }





        function forum_attach_content($args, $is_post = 0){

            global $_G;

            extract($args);

            $tid = $this->cache['common']['tid'];
            
            $uid = $is_post ? $this->cache['common']['reply_public_uid'] : $this->cache['common']['public_uid'];
            $public_time = $is_post ? $this->cache['common']['reply_public_time'] : $this->cache['common']['public_time'];
            $fid = $this->cache['common']['fid'];
            

            require_once libfile('class/image');


            $attach_arr = $is_post == 0 ? $this->post_data['attach_data']['content'] : $this->post_data['attach_data']['reply'];


            if(!$attach_arr || count($attach_arr) == 0) return;

            $public_time = $public_time ? $public_time : $_G['timestamp'];


            bimu_upload_class();
            $upload = new discuz_upload();
            $attachaids = array();
            $threadimage_flag = 0;
            $content_md5_arr = $imagereplace = array();
            $thread_image_data =  array();


            //处理a标签
            foreach($attach_arr as $key => $value){

                $imageurl = $value['src'];
                $hash = md5($imageurl);
                if(!strlen($imageurl)) continue;

                if($value['isimage'] == 'true') continue;//

                if($value['user_oss_url']){
                    $imageurl = $value['user_oss_url'];
                }

                $img_content = $value['download_status'] == 1 && !empty($value['fpath']) ? file_get_contents($value['fpath']) : null;


                $style_str = $value['style'] ? 'style="'.$value['style'].'"' : '';

                $imagereplace['oldimageurl'][$key] = $value['ref'];
                $imagereplace['newimageurl'][$key] = $this->post_data['field_ext']['is_htmlon'] == 1 ? '<a '.$style_str.' href="'.$imageurl.'">'.$value['text'].'</a>' : '[url='.$imageurl.']'.$value['text'].'[/url]';
                $existentimg[$hash] = $imageurl;

                $file_ext = $value['ext'] = $value['ext'];

                $isimage = $value['isimage'];


                if(empty($img_content) || empty($file_ext)) {
                    continue;
                }

                $attach_info = $this->attach_add(array('tid' => $tid, 'fid' => $fid, 'uid' => $uid, 'pid' => $pid, 'attach_img_info' => $value, 'attach_content' => $img_content), $is_post);

                if(!$attach_info['aid']) continue;
                $tableid = $attach_info['tableid'];
                $attachaids[$hash] = $imagereplace['newimageurl'][$key] = '[align=center][attach]'.$attach_info['aid'].'[/attach][/align]';
                $newaids[] = $attach_info['aid'];


            }


            $content = str_replace($imagereplace['oldimageurl'], $imagereplace['newimageurl'], $content);



            $imagereplace = array();

            //处理img标签
            foreach($attach_arr as $key => $value){

                $imageurl = $value['src'];
                $hash = md5($imageurl);
                if(!strlen($imageurl)) continue;


                if($value['isimage'] !== 'true') continue;//


                if($value['user_oss_url']){
                    $imageurl = $value['user_oss_url'];
                }

                $imagereplace['oldimageurl'][$key] = $value['ref'];
                $imagereplace['newimageurl'][$key] = $this->post_data['field_ext']['is_htmlon'] == 1 ? '<img src="'.$imageurl.'" >' :'[img]'.$imageurl.'[/img]';
                $existentimg[$hash] = $imageurl;


                $img_content = $value['download_status'] == 1 && !empty($value['fpath']) ? file_get_contents($value['fpath']) : null;

                $file_ext = $value['ext'];

                $isimage = $value['isimage'];


                if(empty($img_content) || empty($file_ext)) {
                    continue;
                }

                $attach_info = $this->attach_add(array('tid' => $tid, 'fid' => $fid, 'uid' => $uid, 'pid' => $pid, 'attach_img_info' => $value, 'attach_content' => $img_content), $is_post);//Ìí¼Ó¸½¼þ
                

                $file_path = $attach_info['path'];

                if(!$attach_info['aid']) continue;


                if($value['isimage'] == 'true') {
                    $imginfo = @getimagesize($file_path);
                    $width = $imginfo[0];
                    if($thread_image_data['max_width'] == 0 || ($width > intval($thread_image_data['max_width']))){
                        $thread_image_data['max_width'] = $width;
                        $thread_image_data['aid'] = $attach_info['aid'];
                        $thread_image_data['data'] = array(
                            'tid' => $tid,
                            'attachment' => $attach_info['attachment'],
                            'remote' => getglobal('setting/ftp/on') ? 1 : 0,
                        );

                    }
                }

                $tableid = $attach_info['tableid'];
                //$attachaids[$hash] = $imagereplace['newimageurl'][$key] = '[align=center][attach]'.$attach_info['aid'].'[/attach][/align]';
                $attachaids[$hash] = $imagereplace['newimageurl'][$key] = '[attach]'.$attach_info['aid'].'[/attach]';
                
                $newaids[] = $attach_info['aid'];


            }



           


            if($thread_image_data['aid'] && !$is_post){
                DB::insert('forum_threadimage', $thread_image_data['data'], true);
            }
            $this->cache['upload']['newaids'][$pid] = array('uid' => $uid, 'aids' => $newaids);

            $content = str_replace($imagereplace['oldimageurl'], $imagereplace['newimageurl'], $content);


            //print_r($imagereplace);

            //exit();


            $attachment = ( count($newaids)  > 0) ? 2 : 0;

            $setarr = array();
            require_once libfile('function/editor');
            require_once libfile('function/home');
            $setarr['attachment'] = $attachment;
            $setarr['message'] = $content;
            $is_htmlon = $this->post_data['field_ext']['is_htmlon'];
            $setarr['message'] = content_html_ubb($setarr['message'], $this->post_data['node_data']['url'], $is_htmlon);


            $bbcodeoff = checkbbcodes($setarr['message'], FALSE);
            $setarr['bbcodeoff'] = $bbcodeoff;
            $setarr = paddslashes($setarr);


            DB::update('forum_post', $setarr, array('pid' => $pid));

            if(!$is_post || $is_post > 0 && $attachment > 0) {


                DB::update('forum_thread', array('attachment' => $attachment), array('tid' => $tid));

                //如果设置了封面，就不需要再设置
                if($this->cache['common']['is_set_cover'] == 0){

                    if(getglobal('setting/ftp/on')){

                        require_once libfile('function/post');
                        $_G['forum']['ismoderator'] = 1;
                        $_G['uid'] = $this->cache['common']['public_uid'];
                        $_G['uid'] = $_G['uid'] ? $_G['uid'] : 1;
                        setthreadcover($this->cache['common']['pid']);


                    }else{
                        $_G['forum']['ismoderator'] = 1;
                        $_G['uid'] = $uid;
                        $_G['uid'] = $_G['uid'] ? $_G['uid'] : 1;
                        setthreadcover($this->cache['common']['pid']);
                    }

                }

            }

        }


        function attach_add($args, $is_post = 0){

            extract($args);
            global $_G;
            require_once libfile('class/image');
            $img_content = $attach_content;
            bimu_upload_class();
            $upload = new discuz_upload();



            if(strlen($img_content) == 0) return -1;

            $public_time = $this->cache['common']['public_time'];
            $attach['name'] = $attach_img_info['realName'] ? $attach_img_info['realName'] : $attach_img_info['_id'].'.'.$attach_img_info['ext'];
            $attach['ext'] = trim($attach_img_info['ext']);
            $attach['thumb'] = '';
            $attach['isimage'] = $upload -> is_image_ext($attach['ext']);
            $attach['extension'] = $upload -> get_target_extension($attach['ext']);
            $attach['attachdir'] = $upload -> get_target_dir('forum');
            $attach['attachment'] = $attach['attachdir'] . $upload->get_target_filename('forum').'.'.$attach['extension'];
            $attach['target'] = getglobal('setting/attachdir').'./forum/'.$attach['attachment'];


            if(!@$fp = fopen($attach['target'], 'wb')) {
                return -2;
            } else {
                flock($fp, 2);
                fwrite($fp, $img_content);
                fclose($fp);
            }


            if(!$upload->get_image_info($attach['target']) && $attach['isimage'] == 1) {
                @unlink($attach['target']);
                return -3;
            }


            $attach['size'] = filesize($attach['target']);

            $remote = 0;
            if($_G['setting']['ftp']['on'] && $this->ftp_check_attach($attach['ext'], $attach['size'])){
                $result = ftpcmd('upload', 'forum/'.$attach['attachment']);
                $remote = 1;
            }


            $upload->attach = $attach;
            $thumb = $width = 0;
            if($upload->attach['isimage']) {
                if($_G['setting']['thumbstatus']) {
                    $image = new image();
                    $thumb = $image->Thumb($upload->attach['target'], '', $_G['setting']['thumbwidth'], $_G['setting']['thumbheight'], $_G['setting']['thumbstatus'], $_G['setting']['thumbsource']) ? 1 : 0;
                    $width = $image->imginfo['width'];
                }
                if($_G['setting']['thumbsource'] || !$_G['setting']['thumbstatus']) {
                    list($width) = @getimagesize($upload->attach['target']);
                }
                if(($_G['setting']['watermarkstatus'] && empty($_G['forum']['disablewatermark']))) {
                    $image = new image();
                    $image->Watermark($attach['target'], '', 'forum');
                }
            }


            $picid = 0;
            $setarr = array(
                'uid' => $uid,
                'tid' => $tid,
                'pid' => $pid,
                'filename' => daddslashes($upload->attach['name']),
                'attachment' => $upload->attach['attachment'],

                'filesize' => $upload->attach['size'],
                'thumb' => $thumb,
                'remote' => $remote,
                'picid' => $picid,
                'isimage' => $attach['isimage'],
                'description' => $attach_img_info['alt'] ? $attach_img_info['alt'] : $attach_img_info['text'],
                'readperm' => 0,
                'price' => 0,
                'width' => $width,
                'dateline' => $public_time,
            );


            $setimg_arr = array(
                'tid' => $tid,
                'attachment' => $upload->attach['attachment'],
                'remote' => $remote,
            );
            $set_att = array(
                'downloads' => rand(1,15),
                'tableid' => getattachtableid($tid),
                'uid' => $uid,
                'tid' => $tid,
                'pid' => $pid,
            );

            $setarr['aid'] = $newaids[] = DB::insert('forum_attachment', $set_att, true);
            $at[] = $setarr['aid'];


            $attachnew_arr[$setarr['aid']] = array('description' => $setarr['description']);
            DB::insert(getattachtablebytid($tid), paddslashes($setarr), true);
            return array('aid' => $setarr['aid'], 'path' => $attach['target'],  'url' => $_G['setting']['attachurl'].'forum/'.$attach['attachment'], 'tableid' => $set_att['tableid'], 'attachment' => $attach['attachment']);
        }



        function check_article_forum(){
            return true;
        }

        private function get_public_member_info($public_username = '', $public_uid = ''){

            global $_G;


            if($public_username){
                $info = DB::fetch_first("SELECT uid,username FROM ".DB::table('common_member')." WHERE username='$public_username'");
            }

            if($info){
                return array(
                    'uid' => $info['uid'],
                    'username' => $info['username'],
                );
            }

            $public_uid = $public_uid ? $public_uid : $_G['uid'];
            if(!$public_uid) $public_uid = 1;

            $info = DB::fetch_first("SELECT uid,username FROM ".DB::table('common_member')." WHERE uid='$public_uid'");

            if(!$info){

                return array(

                    'uid' => $_G['uid'],
                    'username' => $_G['username'],
                );

            }else{

                return array(
                    'uid' => $info['uid'],
                    'username' => $info['username'],
                );
            }

        }

        function init_error(){

        }

        function move_forums(){

            global $_G;
            require_once libfile('function/editor');
            require_once libfile('function/forum');
            require_once libfile('function/post');
            require_once libfile('function/home');

            if($this->check_article_forum() == FALSE) return FALSE;


            $old_forum_id = $this->post_data['data_id'];//旧的发布id


            $old_tid = '';//旧的发布id

            $subject = $this->post_data['field_data']['title'];
            $message = $this->post_data['field_data']['content'];


            $subject = getstr($subject, 80, 0, 0);


            $is_htmlon = $this->post_data['field_ext']['is_htmlon'];


            $message = content_html_ubb($message, $this->post_data['field_data']['url'], $is_htmlon);

            $bbcodeoff = checkbbcodes($message, FALSE);
            $smileyoff = checksmilies($message, FALSE);

            $readperm = 0;
            $displayorder = 0;
            $digest = 0;
            $moderated = 0;
            $isgroup = 0;
            $replycredit = 0;
            $isanonymous = 0;
            $parseurloff = 0;

            $view_num = $this->post_data['field_ext']['view_num'];

            $fid = $this->post_data['cat_data']['cid'];

            $_G['forum'] =  DB::fetch_first("SELECT * FROM ".DB::table('forum_forum')." WHERE fid='$fid'");
            
            $forum_forumfield_info = DB::fetch_first("SELECT threadsorts,moderators FROM ".DB::table('forum_forumfield')." WHERE fid='$fid'");

            $_G['forum']['threadsorts'] = dunserialize($forum_forumfield_info['threadsorts']);
            $_G['forum']['moderators'] = $forum_forumfield_info['moderators'];

            $this->cache['common']['forum'] = $_G['forum'];

            $public_username = $this->post_data['field_data']['public_username'];
            $public_uid = $this->post_data['field_ext']['public_uid'];
            $member_info = $this->get_public_member_info($public_username, $public_uid);

            $uid = $member_info['uid'];
            $author = $member_info['username'];

            $public_time = $this->get_article_dateline();


            $special = 0; //后续可能要改
            $sortid = $this->post_data['cat_data']['ext']['sortid'];//分类信息


            /*
            if($sortid && !in_array($sortid, array_keys($_G['forum']['threadsorts']['types']))){

                $this->cache['error'] = array(
                    'status' => -1,
                    'msg' => '请选择分类信息',
                );
                return FALSE;
            }*/

            if($special == 3){
                $price = $rewardprice = $this->api_info['reward_price'] ? $this->api_info['reward_price'] : rand(1,50);
            }

            $typeid = $this->post_data['cat_data']['ext']['typeid'];

        

            if($old_forum_id){
                $info = DB::fetch_first("SELECT p.pid,p.tid,t.tid,p.first,t.replies FROM ".DB::table('forum_post')." p Inner Join ".DB::table('forum_thread')." t  ON p.tid = t.tid WHERE p.first = '1' AND t.tid='".$old_forum_id."' AND t.displayorder > '-1'");
                $old_tid = $info['tid'];
            }

            $this->cache['common']['subject'] = $subject;

            if($old_tid){

                DB::query("UPDATE ".DB::table('forum_thread')." SET typeid='$typeid', author='".daddslashes($author)."', sortid='$sortid', authorid='$uid', subject='".daddslashes($subject)."', dateline='$public_time', price='$price', lastpost='$public_time', special='$special', fid='$fid', lastposter='".daddslashes($author)."', views='$view_num', attachment='0', replies ='0'  WHERE tid='".$old_tid."'", 'UNBUFFERED');
                $tid = $old_tid;
                $forum_info = DB::fetch_first("SELECT fid,posts,threads FROM ".DB::table('forum_forum')." WHERE fid='$fid'");
                $forum_info['posts'] -= $info['replies'];
                $forum_info['posts'] = max(0, $forum_info['posts']);

                $forum_info['threads'] -= 1;
                $forum_info['threads'] = max(0, $forum_info['threads']);

                DB::query("UPDATE ".DB::table('forum_forum')." SET  posts='".$forum_info['posts']."',threads='".$forum_info['threads']."' WHERE fid='".$fid."'", 'UNBUFFERED');


            }else{
                DB::query("INSERT INTO ".DB::table('forum_thread')." (fid, posttableid, readperm, price, typeid, sortid, author, authorid, subject, dateline, lastpost, lastposter, views, displayorder, digest, special, attachment, moderated, status, isgroup, replycredit, closed)
                    VALUES ('".$fid."', '0', '$readperm', '$price', '$typeid', '$sortid', '".daddslashes($author)."', '$uid', '".daddslashes($subject)."', '$public_time', '$public_time', '".daddslashes($author)."', '$view_num', '$displayorder', '$digest', '$special', '0', '$moderated', '32', '$isgroup', '$replycredit', '0')");
                $tid = DB::insert_id();
                useractionlog($uid, 'tid');

            }
            $this->cache['finish']['data_id'] = $tid;
            DB::update('common_member_field_home', array('recentnote'=> daddslashes($subject)), array('uid'=> $uid));


            if(DISCUZ_VERSION == 'X2'){
                $tagstr = addthreadtag($this->post_data['field_ext']['tags'], $tid);
            }else{
                $class_tag = new tag();
                $tagstr = $class_tag->add_tag($this->post_data['field_ext']['tags'], $tid, 'tid');

            }

            $message = preg_replace('/\[attachimg\](\d+)\[\/attachimg\]/is', '[attach]\1[/attach]', $message);
          

            $post_setarr = array(
                'fid' => $fid,
                'tid' => $tid,
                'first' => '1',
                'author' => $author,
                'authorid' => $uid,
                'subject' => $subject,
                'dateline' => $public_time,
                'message' => $message,
                'useip' => $_G['clientip'],
                'invisible' => 0,
                'anonymous' => $isanonymous,
                'usesig' => 1,
                'htmlon' => $is_htmlon,
                'bbcodeoff' => $bbcodeoff,
                'smileyoff' => $smileyoff,
                'parseurloff' => $parseurloff,
                'attachment' => '0',
                'replycredit' => 0,
                'status' => 0
            );

            if(DISCUZ_VERSION != 'X2'){
                $post_setarr['position'] = 1;
            }

            $post_setarr = paddslashes($post_setarr);
            $post_setarr['tags'] = $tagstr;
            $today_time_arr = array();
            $replys = 0;

            if($info['tid']){
                $new_post_arr = DB::fetch_first("SELECT dateline FROM ".DB::table('forum_post')." WHERE tid='$tid' ORDER BY dateline ASC limit 1");
                $post_setarr['dateline'] = $post_setarr['dateline'] - 3600;
                DB::update('forum_post', $post_setarr, array('pid' => $info['pid']));
                $pid =  $info['pid'];

            }else{
                $pid = insertpost($post_setarr);
            }



            $threadimageaid = 0;
            $threadimage = array();



            if($old_forum_id){
                $tidsadd = "tid='".$old_forum_id."'";
                require_once libfile('function/delete');
                deleteattach(array($old_forum_id), 'tid');
                DB::query("UPDATE ".DB::table('forum_thread')." SET attachment='0' WHERE $tidsadd");
                updatepost(array('attachment' => '0'), $tidsadd);

                DB::delete('forum_post', "tid='".$old_forum_id."' AND pid<>'$pid'");

            }



            if(!empty($sortid)){

                loadcache(array('threadsort_option_'.$sortid));
                $sortoptionarray = $_G['cache']['threadsort_option_'.$sortid];

                foreach($sortoptionarray as $k => $v){

                    $data_type = $v['type'];
                    $data_id = $v['identifier'];
                    $optionid = $k;

                    $value =  $this->post_data['field_data'][$data_id];
                    $value = trim($value);


                    //图片
                    if($data_type == 'image') {

                        $attach_img_info = $this->post_data['attach_data'][$data_id][0];

                        $attach_content = $attach_img_info['download_status'] == 1 && !empty($attach_img_info['fpath']) ? file_get_contents($attach_img_info['fpath']) : null;

                        $attach_info = strlen($attach_content) > 0 ? $this->attach_add(array('tid' => $tid, 'fid' => $fid, 'uid' => $uid, 'pid' => $pid, 'attach_img_info' => $attach_img_info, 'attach_content' => $attach_content)) : array();


                        if($attach_info['aid']){
                            $value = st_serialize($attach_info);
                        }else{

                        }

                    }



                    //多选、选择什么的
                    if($data_type == 'select' || $data_type == 'checkbox' || $data_type == 'radio') {
                        $search_key = array_search($value, $v['choices']);
                        if(empty($search_key)){
                            foreach($v['choices'] as $k1 => $v1){
                                if(strexists($value, trim($v1))){
                                    $value = $k1;
                                    break;
                                }
                                if(strexists(trim($v1), $value)){
                                    $value = $k1;
                                    break;
                                }
                            }
                        }else{
                            $value = $search_key;
                        }

                    }

                    if($value) {
                        $filedname .= $separator.$data_id;
                        $valuelist .= $separator."'".daddslashes($value)."'";
                        $separator = ' ,';
                    }


                    DB::query("INSERT INTO ".DB::table('forum_typeoptionvar')." (sortid, tid, fid, optionid, value, expiration)
                        VALUES ('$sortid', '$tid', '$fid', '$optionid', '".daddslashes($value)."', '".($typeexpiration ? TIMESTAMP + $typeexpiration : 0)."')");



                }


                if($filedname && $valuelist) {
                    DB::query("INSERT INTO ".DB::table('forum_optionvalue')."$sortid ($filedname, tid, fid) VALUES ($valuelist, '$tid', '$fid')");
                }



            }



            $param = array('fid' => $fid, 'tid' => $tid, 'pid' => $pid);

            $statarr = array(0 => 'thread', 1 => 'poll', 2 => 'trade', 3 => 'reward', 4 => 'activity', 5 => 'debate', 127 => 'thread');

            include_once libfile('function/stat');

            updatestat($isgroup ? 'groupthread' : $statarr[$special]);

            dsetcookie('clearUserdata', 'forum');


            if($specialextra) {

                $classname = 'threadplugin_'.$specialextra;
                if(class_exists($classname) && method_exists($threadpluginclass = new $classname, 'newthread_submit_end')) {
                    $threadpluginclass->newthread_submit_end($fid, $tid);
                }

            }



            $feed = array(
                'icon' => '',
                'title_template' => '',
                'title_data' => array(),
                'body_template' => '',
                'body_data' => array(),
                'title_data'=>array(),
                'images'=>array()
            );

            if($_G['forum']['allowfeed'] && !$isanonymous) {
                $message = !$price ? $message : '';
                if($special == 0) {
                    $feed['icon'] = 'thread';
                    $feed['title_template'] = 'feed_thread_title';
                    $feed['body_template'] = 'feed_thread_message';
                    $feed['body_data'] = array(
                        'subject' => "<a href=\"forum.php?mod=viewthread&tid=$tid\">$subject</a>",
                        'message' => messagecutstr($message, 150)
                    );

                }elseif($special == 3) {
                    $feed['icon'] = 'reward';
                    $feed['title_template'] = 'feed_thread_reward_title';
                    $feed['body_template'] = 'feed_thread_reward_message';
                    $feed['body_data'] = array(
                        'subject'=> "<a href=\"forum.php?mod=viewthread&tid=$tid\">$subject</a>",
                        'rewardprice'=> $rewardprice,
                        'extcredits' => $_G['setting']['extcredits'][$_G['setting']['creditstransextra'][2]]['title'],
                    );
                }
            }

            $feed['title_data']['hash_data'] = "tid{$tid}";
            $feed['id'] = $tid;
            $feed['idtype'] = 'tid';
            if($feed['icon']) {
                postfeed($feed);
            }


            if($displayorder != -4) {

                updatepostcredits('+',  $uid, 'post', $fid);

                $subject = str_replace("\t", ' ', daddslashes($subject));
                $f_lastpost = "$tid\t$subject\t".$public_time."\t".daddslashes($author);
                if($_G['forum']['type'] == 'sub') {
                    DB::query("UPDATE ".DB::table('forum_forum')." SET lastpost='$f_lastpost' WHERE fid='".$_G['forum'][fup]."'", 'UNBUFFERED');
                }
            }

            $subject = str_replace("\t", ' ', daddslashes($subject));

            $todayposts = 1;

            DB::query("UPDATE ".DB::table('forum_forum')." SET lastpost='$f_lastpost', threads=threads+1, posts=posts+$replys, todayposts=todayposts+$todayposts WHERE fid='$fid'", 'UNBUFFERED');


            $this->cache['common']['tid'] = $tid;
            $this->cache['common']['public_uid'] = $uid;
            $this->cache['common']['public_username'] = $author;
            $this->cache['common']['public_time'] = $public_time;
            $this->cache['common']['fid'] = $fid;
            $this->cache['common']['pid'] = $pid;

            $this->cache['finish']['data_url'] = $_G['siteurl'].'forum.php?mod=viewthread&tid='.$this->cache['finish']['data_id'];

            $this->cache['common']['is_set_cover'] = 0;

            //没有附件的情况下，设置封面
            $_G['setting']['forumpicstyle']  = $this->load_forumpicstyle();

            if($_G['setting']['forumpicstyle']) {

                $attach_img_info = $this->post_data['attach_data']['thumb'][0];

                $imageurl = '';

                $img_content = $attach_img_info['download_status'] == 1 && !empty($attach_img_info['fpath']) ? file_get_contents($attach_img_info['fpath']) : null;

                if($attach_img_info && strlen($img_content) > 0){
                    $temp_avatar_dir = $_G['setting']['attachdir'].'./yuncaix/';
                    dmkdir($temp_avatar_dir);
                    $temp_path =  $temp_avatar_dir.$attach_img_info['_id'].'.'.$attach_img_info['ext'];
                    file_put_contents($temp_path, $img_content);
                    $this->forum_set_cover($tid, $temp_path);
                    @unlink($temp_path);
                    $this->cache['common']['is_set_cover'] = 1;
                }

            }

            $this->forum_attach_content(
                array('content' => $this->post_data['field_data']['content'], 'pid' => $pid)
            );


        }

        function load_forumpicstyle(){

            global $_G;
            $fid = $this->cache['common']['fid'];
            $forumpicstyle = DB::result_first("SELECT picstyle FROM ".DB::table('forum_forumfield')." WHERE fid='$fid'");
            if(!$forumpicstyle) return;
            loadcache('setting');
            if(DISCUZ_VERSION != 'X2.5' && DISCUZ_VERSION != 'X2'){//3.1ÒÔÉÏÓÐÆÙ²¼Á÷
                $width = 203;
                $height = 999;
            }else{
                $width = 214;
                $height = 160;
            }
            if($_G['setting']['forumpicstyle']) {
                if(!is_array($_G['setting']['forumpicstyle'])) $_G['setting']['forumpicstyle'] = dunserialize($_G['setting']['forumpicstyle']);
                empty($_G['setting']['forumpicstyle']['thumbwidth']) && $_G['setting']['forumpicstyle']['thumbwidth'] = $width;
                empty($_G['setting']['forumpicstyle']['thumbheight']) && $_G['setting']['forumpicstyle']['thumbheight'] = $height;
            } else {
                $_G['setting']['forumpicstyle'] = array('thumbwidth' => $width, 'thumbheight' => $height);
            }
            return $_G['setting']['forumpicstyle'];

        }




        function reply_public(){

            global $_G;

            require_once libfile('function/editor');
            require_once libfile('function/post');
            require_once libfile('function/forum');

            $message = $this->post_data['field_data']['reply'];

            $fid = $this->post_data['cat_data']['cid'];
            $tid = $this->post_data['data_id'];

            $is_htmlon = $this->post_data['field_ext']['is_htmlon'];

            $subject = '';

            if(!$message || strlen($message) < 2) return;

            $reply_content = $message;

            $message = content_html_ubb($message, $this->post_data['node_data']['url'], $is_htmlon);

            $bbcodeoff = checkbbcodes($message, !empty($_GET['bbcodeoff']));
            $smileyoff = checksmilies($message, !empty($_GET['smileyoff']));

            $parseurloff = 0;
            $usesig = 1;
            $isanonymous = 0;

            $dateline = $this->post_data['field_data']['reply_dateline'];;
           
            $reply_username = $this->post_data['field_data']['reply_username'];


            $reply_username = $this->post_data['field_data']['reply_username'];
            $reply_uid = $this->post_data['field_ext']['reply_uid'];
            
            $member_info = $this->get_public_member_info($reply_username, $reply_uid);

            $authorid = $member_info['uid'];
            $author = $member_info['username'];

            

            $post_setarr = array(
                'fid' => $fid,
                'tid' => $tid,
                'first' => '0',
                'author' => $author,
                'authorid' => $authorid,
                'subject' => $subject,
                'dateline' => $dateline,
                'message' => $message,
                'useip' => $_G['clientip'],
                'invisible' => 0,
                'anonymous' => $isanonymous,
                'usesig' => $usesig,
                'htmlon' => $is_htmlon,
                'bbcodeoff' => $bbcodeoff,
                'smileyoff' => $smileyoff,
                'parseurloff' => $parseurloff,
                'attachment' => '0',
                'tags' => 0,
                'replycredit' => 0,
                'status' => (defined('IN_MOBILE') ? 8 : 0)
            );

            $post_setarr = paddslashes($post_setarr);

            $lastpost = $post_setarr['dateline'];
            $lastposter = $post_setarr['author'];
            $reply_pid = insertpost($post_setarr);

            $this->cache['common']['reply_public_uid'] = $authorid;
            $this->cache['common']['tid'] = $tid;
            $this->cache['common']['reply_public_time'] = $dateline;
            $this->cache['common']['fid'] = $fid;
            $this->cache['common']['pid'] = $reply_pid;

            DB::query("UPDATE ".DB::table('common_member_count')." SET posts=posts+1 WHERE uid='$post_setarr[authorid]'");
          
            $this->forum_attach_content(array('content' => $reply_content, 'pid' => $reply_pid ), 1);




            $this->reply_public_finish(array( 
                'todayposts' => 1, 
                'replies' => 1, 
                'lastpost' => $lastpost, 'lastposter' => $lastposter, 
                'tid' => $tid, 
                'fid' => $fid)
            );


            $this->cache['finish']['data_id'] = $reply_pid;

            $this->cache['finish']['data_url'] = $_G['siteurl'].'forum.php?mod=viewthread&tid='.$tid.'&pid='.$reply_pid;

            return;

                
        }


        function reply_public_finish($args){

            global $_G;

            extract($args);

            $replies = max($replies, 0);

            DB::update('forum_thread', array('lastpost' => $lastpost, 'lastposter' => $lastposter), array('tid'=> $tid));
            
            DB::query('UPDATE '.DB::table('forum_thread')." SET replies=replies+$replies WHERE tid='".$tid."'");
           
            $subject = str_replace("\t", ' ', daddslashes($subject));
            $replys = $replies ? $replies : 1;
            $forum_lastpost = "$tid\t$subject\t$lastpost\t".daddslashes($lastposter)."";
            DB::query("UPDATE ".DB::table('forum_forum')." SET lastpost='$forum_lastpost', posts=posts+$replys, todayposts=todayposts+$todayposts WHERE fid='".$fid."'", 'UNBUFFERED');//¸üÐÂ½ñÈÕ·¢ÌûÕâÐ©Êý¾Ý
            
            loadcache('posttableids');

		    $posttableids = $_G['cache']['posttableids'] ? $_G['cache']['posttableids'] : array('0');
            
            $rinfo = DB::fetch_first("SELECT * FROM ".DB::table('forum_thread')." WHERE tid='".$tid."'");

            $updatedata = array(
				'replies' => $rinfo['replies'],
                'maxposition' => $rinfo['replies'] + 1,
			); 


			C::t('forum_thread')->update($tid, $updatedata, true, true);

            C::t('forum_thread')->clear_cache($tid);

        }






        function get_article_dateline(){

            global $_G;

            $dateline = $this->post_data['field_ext']['public_time'];
            $dateline = $dateline ? $dateline : $_G['timestamp'];

            return $dateline;

        }





    }

?>
