<?php


class BimuCommon{


	static function dmkdir($dir, $mode = 0777, $makeindex = TRUE){
		if(!is_dir($dir)) {
			self::dmkdir(dirname($dir), $mode, $makeindex);
			@mkdir($dir, $mode);
			if(!empty($makeindex)) {
				@touch($dir.'/index.html'); @chmod($dir.'/index.html', 0777);
			}
		}
		return true;
	}


	static function base64_decode($data) {

		if(is_array($data)){
			foreach($data as $k => $v){
				$data[$k] = self::base64_decode($v);
			}
		}else{
			if(strlen($data) > 0){
				$data = base64_decode(str_replace(" ", "+", $data));
			}
		}

	    return $data;

	}

	static function get_post_data(){
		$post_data = json_decode(self::base64_decode($_POST['data']), true);
		$post_data = self::base64_decode($post_data);
		return $post_data;
	}


	static function strexists($string, $find) {
		return !(strpos($string, $find) === FALSE);
	}

	
}

?>
