<?php


if(!function_exists('portalcp_get_summary')){
    function portalcp_get_summary($message) {
        $message = preg_replace(array("/\[attach\].*?\[\/attach\]/", "/\&[a-z]+\;/i", "/\<script.*?\<\/script\>/"), '', $message);
        $message = preg_replace("/\[.*?\]/", '', $message);
        require_once libfile('function/home');
        $message = getstr(strip_tags($message), 200);
        return $message;
    }
}

if(!function_exists('portalcp_article_pre_next')){
    function portalcp_article_pre_next($catid, $aid) {
        $data = array(
                      'preaid' => C::t('portal_article_title')->fetch_preaid_by_catid_aid($catid, $aid),
                      'nextaid' => C::t('portal_article_title')->fetch_nextaid_by_catid_aid($catid, $aid),
                      );
        if($data['preaid']) {
            C::t('portal_article_title')->update($data['preaid'], array(
                                                                        'preaid' => C::t('portal_article_title')->fetch_preaid_by_catid_aid($catid, $data['preaid']),
                                                                        'nextaid' => C::t('portal_article_title')->fetch_nextaid_by_catid_aid($catid, $data['preaid']),
                                                                        )
                                                 );
        }
        return $data;
    }
}



	function st_addslashes($data){
		if(DISCUZ_VERSION != 'X2') return $data;
		return daddslashes($data);
	}


	function format_wrap($str, $exp_type = PHP_EOL){
		if(!$str) return false;
		$arr = explode($exp_type, trim($str));
		$arr = array_map('trim',$arr);
		$arr = array_filter($arr);
		return $arr;
	}


	function stlang($key){

		

		loadcache('pluginlanguage_script', true);
		loadcache('pluginlanguage_system', true);

		global $_G;
		global $scriptlang;

		$lang = $scriptlang['bimu'];
		
		if($lang[$key]) return $lang[$key];

		$res = lang('plugin/bimu', $key);

		return $res;
	}

	function bimu_get_attach_save_path($data_id, $attach_id){

		$dir = PLUGIN_ATTACH_CACHE_DIR.'/'.$data_id.'/';


		$res = BimuCommon::dmkdir($dir);

		$fpath = $dir.''.$attach_id;

		return $fpath;

	}


	function bimu_tool_common_get($key = ''){
		global $_G;
		loadcache('bimu_setting');
		$setting = $_G['cache']['bimu_setting'];
		$setting = dstripslashes($setting);
		$setting = $key ? $setting[$key] : $setting;
		return $setting;
	}


	function bimu_tool_common_set($name, $value, $flag = ''){
		$conf_arr = bimu_tool_common_get();
		$setting = $conf_arr[$name];
		$value = (array)$value;
		$setting = (array)$setting;
		$value += $setting;
		$conf_arr[$name] = $value;
		save_syscache('bimu_setting', $conf_arr);
	}
	
	
	
	function bimu_get_api_key(){
	
		$global = bimu_tool_common_get('global');
		$api_key = $global['api_key'];
		if(!$api_key) {
	
			$set['api_key'] = $api_key = random(20);
			bimu_tool_common_set('global', $set);
	
		}
	
		return $api_key;
	}


	function bimu_upload_class(){
		if(file_exists(libfile('class/upload'))){
			require_once libfile('class/upload');
		}else{
			require_once libfile('discuz/upload', 'class');
		}
	}


	function sload($name){
		$arr = explode(',', $name);
		$temp_arr = array();
		$pick_dir = DISCUZ_ROOT.'source/plugin/bimu';
		foreach($arr as $k => $v){
			$temp_arr = explode(':', $v);
			$type = strtolower($temp_arr[0]);
			$name = $temp_arr[1];
			$func_file = $pick_dir.'/lib/function.'.$name.'.php';
			$class_file = $pick_dir.'/lib/'.$name.'.class.php';
			if( (!$type || $type == 'f')){
				require_once($func_file);
			}else if($type == 'c'){
				require_once($class_file);
			}
		}
	}


	function content_html_ubb($content, $page_url, $is_htmlon = 0){

		if(DISCUZ_VERSION == 'X2.5' || DISCUZ_VERSION == 'X2') $is_htmlon = 0;//X3ÒÔÉÏ°æ±¾²ÅÓÐÕâ¸ö¹¦ÄÜ
		if($is_htmlon == 1) return $content;
	
		$content = pick_html2bbcode($content);
		$content = htmlspecialchars_decode($content, ENT_QUOTES);
		$content = format_html($content);
		$content = unhtmlentities($content);
		$content = pick_parseed2k($content);//¶ÔÖÖ×ÓµØÖ·(ed2k://)µÄÌØÊâ´¦Àí
	
		return $content;
	}


	function format_html($str){
		if(!$str) return;
		$format_str = stlang('format_str');
		$format_arr = explode('@', $format_str);
		foreach((array)$format_arr as $k => $v){
			$v_arr = explode('|', $v);
			$strfind[] = $v_arr[0];
			$strreplace[] = $v_arr[1];
		}
		$str = str_replace($strfind, $strreplace, $str);
		$str = str_replace('&nbsp;', ' ', $str);
		if(function_exists('mb_convert_encoding')){
			foreach(get_html_translation_table(HTML_ENTITIES) as $k=>$v) {
				$str = str_replace($v, mb_convert_encoding($v, CHARSET, "HTML-ENTITIES"), $str);
			}
		}
		return $str;
	}



	function pick_html2bbcode($text) {


		//´¦Àípre±êÇ©
		require_once libfile('function/editor');
		$pre_arr = $blockcode_arr = array();
		if(strexists($text, '</pre>')){
			preg_match_all("/<pre.*>(.*)?<\/pre>/isU", $text, $pre_arr, PREG_SET_ORDER);
			if($pre_arr){
				$replace_key = 'DXCPICKPRE_';
				$replace_arr = array();
				foreach($pre_arr as $k => $v){
					$replace_arr['_old'][] = $v[0];
					$replace_arr['old'][] = str_replace($v[1], $replace_key.$k, $v[0]);
					$replace_arr['key'][] = $replace_key.$k;
					$v[1] = strip_tags($v[1], '');
					//$v[1] = str_replace('<br/>', "", $v[1]);
					$replace_arr['new'][] = $v[1];
				}
				$text = str_replace($replace_arr['_old'], $replace_arr['old'], $text);
			}
		}
		//´¦Àíblockcode±êÇ©
		if(strexists($text, '<div class="blockcode">')){
			preg_match_all("/<div class=\"blockcode\">(.*)?<\/em><\/div><br \/>/isU", $text, $blockcode_arr, PREG_SET_ORDER);
			if($blockcode_arr){
				$replace_key = 'DXCPICKCODE_';
				$blockcode_replace_arr = array();
				foreach($blockcode_arr as $k => $v){
					$blockcode_replace_arr['_old'][] = $v[0];
					$blockcode_replace_arr['old'][] = '[code]'.$replace_key.$k.'[/code]';
					$blockcode_replace_arr['key'][] = $replace_key.$k;
					$v[1] = strip_tags($v[1], '<li>');
					$v[1] = str_replace(array('<li>', '¸´ÖÆ´úÂë'), array("\r\n", ''), $v[1]);
					$blockcode_replace_arr['new'][] = '[code]'.$v[1].'[/code]';
				}
				$text = str_replace($blockcode_replace_arr['_old'], $blockcode_replace_arr['old'], $text);
			}
		}

		$text = strip_tags($text, '<table><tr><td><b><strong><i><em><u><a><div><span><p><strike><blockquote><pre><ol><ul><li><font><img><br><br/><h1><h2><h3><h4><h5><h6><script>');
		if(ismozilla()) {
			$text = preg_replace("/(?<!<br>|<br \/>|\r)(\r\n|\n|\r)/", ' ', $text);
		}



		$pregfind = array(
			"/<script.*>.*<\/script>/siU",
			'/on(mousewheel|mouseover|click|load|onload|submit|focus|blur)="[^"]*"/i',
			"/(\r\n|\n|\r)/",
			"/<table.*>/siU",
			"/<tr.*>/siU",
			"/<td>/i",
			"/<\/td>/i",
			"/<\/tr>/i",
			"/<\/table>/i",
			'/<\/h([0-9]+)>/siU',
			"/<a\s+?name=.+?\".\">(.+?)<\/a>/is",
			"/<br.*>/siU",
			"/<span\s+?style=\"float:\s+(left|right);\">(.+?)<\/span>/is",
		);
		$pregreplace = array(
			'',
			'',
			'',
			'[table]',
			'[tr]',
			'[td]',
			'[/td]',
			'[/tr]',
			'[/table]',
			"[/size]\n\n",
			'\1',
			"\n",
			"[float=\\1]\\2[/float]",
		);
		$text = preg_replace($pregfind, $pregreplace, $text);
		$text = preg_replace_callback("/<table([^>]*(width|background|background-color|bgcolor)[^>]*)>/siU", 'html2bbcode_callback_tabletag_1', $text);
		$text = preg_replace_callback("/<td(.+)>/siU", 'html2bbcode_callback_tdtag_1', $text);
		$text = preg_replace_callback('/<h([0-9]+)[^>]*>/siU', 'html2bbcode_callback_1', $text);
		$text = preg_replace_callback("/<img[^>]+smilieid=\"(\d+)\".*>/siU", 'html2bbcode_callback_smileycode_1', $text);
		$text = preg_replace_callback("/<img([^>]*src[^>]*)>/iU", 'html2bbcode_callback_imgtag_1', $text);

		$text = recursion('b', $text, 'simpletag', 'b');
		$text = recursion('strong', $text, 'simpletag', 'b');
		$text = recursion('i', $text, 'simpletag', 'i');
		$text = recursion('em', $text, 'simpletag', 'i');
		$text = recursion('u', $text, 'simpletag', 'u');
		$text = recursion('a', $text, 'atag');
		$text = recursion('font', $text, 'fonttag');
		$text = recursion('blockquote', $text, 'simpletag', 'indent');
		$text = recursion('ol', $text, 'listtag');
		$text = recursion('ul', $text, 'listtag');
		$text = recursion('div', $text, 'divtag');
		$text = recursion('span', $text, 'spantag');
		$text = recursion('p', $text, 'ptag');

		$pregfind = array("/(?<!\r|\n|^)\[(\/list|list|\*)\]/", "/<li>(.*)((?=<li>)|<\/li>)/iU", "/<p.*>/iU", "/<p><\/p>/i", "/(<a>|<\/a>|<\/li>)/is", "/<\/?(A|LI|FONT|DIV|SPAN)>/siU", "/\[url[^\]]*\]\[\/url\]/i", "/\[url=javascript:[^\]]*\](.+?)\[\/url\]/is");
		$pregreplace = array("\n[\\1]", "\\1\n", "\n", '', '', '', '', "\\1");
		$text = preg_replace($pregfind, $pregreplace, $text);

		$strfind = array('&nbsp;', '&lt;', '&gt;', '&amp;');
		$strreplace = array(' ', '<', '>', '&');
		$text = str_replace($strfind, $strreplace, $text);

		return dhtmlspecialchars(trim($text));
	}


	function unhtmlentities ($string) {
		$string = str_replace('&nbsp;', ' ', $string);
		// Get HTML entities table
		$trans_tbl = get_html_translation_table (HTML_ENTITIES, ENT_QUOTES);
		// Flip keys<==>values
		$trans_tbl = array_flip ($trans_tbl);
		// Add support for &apos; entity (missing in HTML_ENTITIES)
		$trans_tbl += array('&apos;' => "'");
		// Replace entities by values
		return strtr ($string, $trans_tbl);
	}


	function pick_parseed2k($message){
		if(strpos($message, 'ed2k://') === FALSE) return $message;
		preg_match_all('/\[url=ed2k:\/\/(.*?)\](.*?)\[\/url\]/is', $message, $block_arr, PREG_SET_ORDER);//DZ2.0ºÍDZ2.5µÄ¸½¼þ
		$search_arr = $replace_arr = array();
		foreach((array)$block_arr as $k => $v){
			$search_arr[] = $v[0];
			$replace_arr[] = '[b]ed2k://'.$v[1].'[/b]';
		}
		if($search_arr[0]){
			$message = str_replace($search_arr, $replace_arr, $message);
		}
		return $message;
	}


	function pstripslashes($data){
		if(DISCUZ_VERSION != 'X2') return $data;
		return dstripslashes($data);
	}
	
	function paddslashes($data){
		if(DISCUZ_VERSION != 'X2') return $data;
		return daddslashes($data);
	}
	
	


	function st_serialize($arr){
		return serialize(dstripslashes($arr));
	}

?>
